﻿*****************内需引致中间品创新代码**************

use 内需引致中间品创新数据.dta,clear


*描述性统计（附表3）
sum M ddem fdem dem profit dindee fdi size funding pro mrk exp
*基准回归(表1)
reg  M ddem i.id i.year,r
  est store e1
reg  M ddem fdi size funding pro mrk exp i.id i.year,r
  est store e2
reg  M fdem i.id i.year,r
  est store e3
reg  M fdem  fdi size funding pro mrk exp i.id i.year,r
  est store e4
reg  M dem i.id i.year,r
  est store e5
reg  M dem fdi size funding pro mrk exp i.id i.year,r
  est store e6
  
  esttab e1 e2 e3 e4 e5 e6  using Table1.rtf, nogap compress replace ///
	        b(%6.3f)  se(%6.3f)  star(* 0.1 ** 0.05 *** 0.01)  ///
			s(r2_p r2_a N) ///
			nonotes  ///
			addnotes(" *** 1% ** 5% * 10%" ///
			        ) 	

*剔除特殊年份和行业经济规模影响的稳健性检验结果（附表4的1-3列）
 reg M ddem fdi size funding pro mrk exp i.id i.year if  year<2020,r
  est store e1
 reg  M fdem fdi size funding pro mrk exp i.id i.year if year<2020,r
  est store e2
 reg M dem fdi size funding pro mrk exp i.id i.year if  year<2020,r
  est store e3

  esttab e1 e2 e3   using Table1.rtf, nogap compress replace ///
	        b(%6.3f)  se(%6.3f)  star(* 0.1 ** 0.05 *** 0.01)  ///
			s(r2_p r2_a N) ///
			nonotes  ///
			addnotes(" *** 1% ** 5% * 10%" ///
			        ) 	
*剔除特殊年份和行业经济规模影响的稳健性检验结果（附表4的4-6列）
sort year id
  by year:egen sumgdp=sum(gdp)
  gen ddemx=ddem/(gdp/sumgdp)
  gen fdemx=fdem/(gdp/sumgdp)
  gen demx=dem/(gdp/sumgdp)
 reg  M ddemx fdi size funding pro mrk exp i.id i.year ,r
  est store e4
 reg M fdemx fdi size funding pro mrk exp i.id i.year ,r
  est store e5
 reg  M demx fdi size funding pro mrk exp i.id i.year,r
  est store e6

esttab e4 e5 e6   using Table1.rtf, nogap compress replace ///
	        b(%6.3f)  se(%6.3f)  star(* 0.1 ** 0.05 *** 0.01)  ///
			s(r2_p r2_a N) ///
			nonotes  ///
			addnotes(" *** 1% ** 5% * 10%" ///
			        ) 	
*考虑时滞效应和改变变量测算方式的稳健性检验结果（附表5）						
sort year id
xtset id year				
 reg  M L.ddem fdi size funding pro mrk exp i.id i.year,r
  est store e1
 reg  M L.fdem fdi size funding pro mrk exp i.id i.year,r
  est store e2
 reg  M L.dem fdi size funding pro mrk exp i.id i.year,r
  est store e3
sort year id
by year:egen medzl=median(M)	
gen zllm=M/medzl
 reg  zllm ddem fdi size funding pro mrk exp i.id i.year,r
  est store e4
 reg  zllm fdem fdi size funding pro mrk exp i.id i.year,r
  est store e5
 reg  zllm dem fdi size funding pro mrk exp i.id i.year,r
  est store e6
 esttab e1 e2 e3 e4 e5 e6  using Table1.rtf, nogap compress replace ///
	        b(%6.3f)  se(%6.3f)  star(* 0.1 ** 0.05 *** 0.01)  ///
			s(r2_p r2_a N) ///
			nonotes  ///
			addnotes(" *** 1% ** 5% * 10%" ///
			        ) 	
*区分实质性创新与策略性创新的稳健性检验结果（附表6）					
sort year id
reg  fm ddem fdi size funding pro mrk exp i.id i.year,r
  est store e1
reg  fm fdem fdi size funding pro mrk exp i.id i.year,r
  est store e2
reg  fm dem fdi size funding pro mrk exp i.id i.year,r
  est store e3
reg  fmxiangdui ddem fdi size funding pro mrk exp i.id i.year,r
  est store e4
reg  fmxiangdui fdem fdi size funding pro mrk exp i.id i.year,r
  est store e5
reg  fmxiangdui dem fdi size funding pro mrk exp i.id i.year,r
  est store e6
esttab e1 e2 e3 e4 e5 e6  using Table1.rtf, nogap compress replace ///
	        b(%6.3f)  se(%6.3f)  star(* 0.1 ** 0.05 *** 0.01)  ///
			s(r2_p r2_a N) ///
			nonotes  ///
			addnotes(" *** 1% ** 5% * 10%" ///
			        ) 					
*双重机器学习模型的内生性检验结果(附表7)					
//1-2列//
sort year id
global Y M 
global X fdi size funding pro mrk exp  i.id i.year
global D ddem  
set seed 1111 
ddml init partial, kfolds(3)
ddml E[D|X]: pystacked $D $X, type(reg) method(lassocv)  //拉索回归
ddml E[Y|X]: pystacked $Y $X, type(reg) method(lassocv) //拉索回归
ddml crossfit
ddml estimate,vce(robust)
 est store e1
   
global Y M 
global X fdi size funding pro mrk exp i.id i.year
global D ddem 
set seed 1111 
ddml init partial, kfolds(5)
ddml E[D|X]: pystacked $D $X, type(reg) method(lassocv)  //拉索回归
ddml E[Y|X]: pystacked $Y $X, type(reg) method(lassocv) //拉索回归
ddml crossfit
ddml estimate,vce(robust)
 est store e2
 
 	      esttab e1 e2  using Table1.rtf, nogap compress replace ///
	        b(%6.3f)  se(%6.3f)  star(* 0.1 ** 0.05 *** 0.01)  ///
			s(r2_p r2_a N) ///
			nonotes  ///
			addnotes(" *** 1% ** 5% * 10%" ///
			        ) 	
//3-4列//
sort year id
by year:egen meanzl=mean(minno_zl)
gen zlll=minno_zl/meanzl	
global Y M 
global X fdi size funding pro mrk exp i.id i.year
global D fdem  
set seed 1111 
ddml init partial, kfolds(3)
ddml E[D|X]: pystacked $D $X, type(reg) method(lassocv)  //拉索回归
ddml E[Y|X]: pystacked $Y $X, type(reg) method(lassocv) //拉索回归
ddml crossfit
ddml estimate,vce(robust)
 est store e1
  
global Y M 
global X fdi size funding pro mrk exp i.id i.year
global D fdem  
set seed 1111 
ddml init partial, kfolds(5)
ddml E[D|X]: pystacked $D $X, type(reg) method(lassocv)  //拉索回归
ddml E[Y|X]: pystacked $Y $X, type(reg) method(lassocv) //拉索回归
ddml crossfit
ddml estimate,vce(robust)
 est store e2
 
 	      esttab e1 e2  using Table1.rtf, nogap compress replace ///
	        b(%6.3f)  se(%6.3f)  star(* 0.1 ** 0.05 *** 0.01)  ///
			s(r2_p r2_a N) ///
			nonotes  ///
			addnotes(" *** 1% ** 5% * 10%" ///
			        ) 	
 
//5-6列//	
global Y M 
global X fdi size funding pro mrk exp i.id i.year
global D dem 
set seed 1111 
ddml init partial, kfolds(3)
ddml E[D|X]: pystacked $D $X, type(reg) method(lassocv)  //拉索回归
ddml E[Y|X]: pystacked $Y $X, type(reg) method(lassocv) //拉索回归
ddml crossfit
ddml estimate,vce(robust)
 est store e1
  
global Y M 
global X fdi size funding pro mrk exp i.id i.year
global D dem 
set seed 1111 
ddml init partial, kfolds(5)
ddml E[D|X]: pystacked $D $X, type(reg) method(lassocv)  //拉索回归
ddml E[Y|X]: pystacked $Y $X, type(reg) method(lassocv) //拉索回归
ddml crossfit
ddml estimate,vce(robust)
 est store e2
 
 	      esttab e1 e2  using Table1.rtf, nogap compress replace ///
	        b(%6.3f)  se(%6.3f)  star(* 0.1 ** 0.05 *** 0.01)  ///
			s(r2_p r2_a N) ///
			nonotes  ///
			addnotes(" *** 1% ** 5% * 10%" ///
			        ) 	
*基于工具变量的内生性检验结果（附表8）  					
ivreg2 M (ddem=iv) fdi size funding pro mrk exp i.id i.year,first r
	  est store e1
ivreg2 M (fdem=iv) fdi size funding pro mrk exp i.id i.year,first r
	  est store e2
ivreg2 M (dem= iv) fdi size funding pro mrk exp i.id i.year,first r
	  est store e3		
	  
  esttab e1 e2 e3 using Table1.rtf, nogap compress replace ///
	        b(%6.3f)  se(%6.3f)  star(* 0.1 ** 0.05 *** 0.01)  ///
			s(r2_p r2_a N) ///
			nonotes  ///
			addnotes(" *** 1% ** 5% * 10%" ///
			        ) 	  
	  
* 机制检验结果(表4)	  
reg  dindee ddem fdi size funding pro mrk exp i.id i.year,r
est store e1
reg  dindee fdem fdi size funding pro mrk exp i.id i.year,r
est store e2
reg  dindee dem fdi size funding pro mrk exp i.id i.year,r
est store e3
reg profit ddem fdi size funding pro mrk exp i.id  i.year,r
est store e4
reg  profit fdem fdi size funding pro mrk exp i.id i.year,r
est store e5
reg  profit dem fdi size funding pro mrk exp i.id i.year,r
est store e6
	
  esttab e1 e2 e3 e4 e5 e6 using Table1.rtf, nogap compress replace ///
	        b(%6.3f)  se(%6.3f)  star(* 0.1 ** 0.05 *** 0.01)  ///
			s(r2_p r2_a N) ///
			nonotes  ///
			addnotes(" *** 1% ** 5% * 10%" ///
			        ) 	  
*双重机器学习模型下的机制检验结果(附表9)
global Y dindee
global X fdi size funding pro mrk exp  i.id i.year
global D ddem  
set seed 1111 
ddml init partial, kfolds(3)
ddml E[D|X]: pystacked $D $X, type(reg) method(lassocv)  //拉索回归
ddml E[Y|X]: pystacked $Y $X, type(reg) method(lassocv) //拉索回归
ddml crossfit
ddml estimate,vce(robust)
  est store e1
  
global Y dindee
global X fdi size funding pro mrk exp  i.id i.year
global D fdem   
set seed 1111 
ddml init partial, kfolds(3)
ddml E[D|X]: pystacked $D $X, type(reg) method(lassocv)  //拉索回归
ddml E[Y|X]: pystacked $Y $X, type(reg) method(lassocv) //拉索回归
ddml crossfit
ddml estimate,vce(robust)
  est store e2 
  
global Y dindee
global X fdi size funding pro mrk exp  i.id i.year
global D dem  
set seed 1111 
ddml init partial, kfolds(3)
ddml E[D|X]: pystacked $D $X, type(reg) method(lassocv)  //拉索回归
ddml E[Y|X]: pystacked $Y $X, type(reg) method(lassocv) //拉索回归
ddml crossfit
ddml estimate,vce(robust)
  est store e3 
  	
global Y profit
global X fdi size funding pro mrk exp  i.id i.year
global D ddem  
set seed 1111 
ddml init partial, kfolds(3)
ddml E[D|X]: pystacked $D $X, type(reg) method(lassocv)  //拉索回归
ddml E[Y|X]: pystacked $Y $X, type(reg) method(lassocv) //拉索回归
ddml crossfit
ddml estimate,vce(robust)
 est store e4
   
global Y profit
global X fdi size funding pro mrk exp  i.id i.year
global D fdem  
set seed 1111 
ddml init partial, kfolds(3)
ddml E[D|X]: pystacked $D $X, type(reg) method(lassocv)  //拉索回归
ddml E[Y|X]: pystacked $Y $X, type(reg) method(lassocv) //拉索回归
ddml crossfit
ddml estimate,vce(robust)
 est store e5
 
global Y profit
global X fdi size funding pro mrk exp  i.id i.year
global D dem  
set seed 1111 
ddml init partial, kfolds(3)
ddml E[D|X]: pystacked $D $X, type(reg) method(lassocv)  //拉索回归
ddml E[Y|X]: pystacked $Y $X, type(reg) method(lassocv) //拉索回归
ddml crossfit
ddml estimate,vce(robust)
  est store e6
esttab e1 e2 e3 e4 e5 e6  using Table1.rtf, nogap compress replace ///
	        b(%6.3f)  se(%6.3f)  star(* 0.1 ** 0.05 *** 0.01)  ///
			s(r2_p r2_a N) ///
			nonotes  ///
			addnotes(" *** 1% ** 5% * 10%" ///
			        ) 	

*异质性检验结果(附表10)
use 内需引致中间品创新数据.dta,clear					
reg M ddem fdi size funding pro mrk exp i.id i.year if main==0,r					
	est store e1		
reg M ddem fdi size funding pro mrk exp  i.id i.year if main==1,r					
	 est store e2
reg M fdem fdi size funding pro mrk exp  i.id i.year if main==0,r					
	est store e3
reg M fdem fdi size funding pro mrk exp  i.id i.year if main==1,r	
    est store e4
reg M dem fdi size funding pro mrk exp  i.id i.year if main==0,r					
	est store e5		
reg M dem fdi size funding pro mrk exp  i.id i.year if main==1,r	
      est store e6
esttab e1 e2 e3 e4 e5 e6  using Table4.rtf, nogap compress replace ///
	        b(%6.3f)  se(%6.3f)  star(* 0.1 ** 0.05 *** 0.01)  ///
			s(r2_p r2_a N) ///
			nonotes  ///
			addnotes(" *** 1% ** 5% * 10%" ///
			        ) 	
					
					
					
					
					
  